<?php
function export_post_meta_boxes()
{
  add_meta_box(
    'export-post',
    esc_html__('Dane widoczne w portalu kulturawzasiegu.pl', 'ekultura'),
    'export_post_meta_box',   // Callback function
    'post',
    'side',
    'high'
  );
  add_meta_box(
    'export-post',
    esc_html__('Dane widoczne w portalu kulturawzasiegu.pl', 'ekultura'),
    'export_post_meta_box',   // Callback function
    'ajde_events',
    'side',
    'high'
  );
  add_meta_box(
    'export-post',
    esc_html__('Dane widoczne w portalu kulturawzasiegu.pl', 'ekultura'),
    'export_post_meta_box',   // Callback function
    'event',
    'side',
    'high'
  );
  add_meta_box(
    'export-post',
    esc_html__('Dane widoczne w portalu kulturawzasiegu.pl', 'ekultura'),
    'export_post_meta_box',   // Callback function
    'tribe_events',
    'side',
    'high'
  );
  add_meta_box(
    'export-post',
    esc_html__('Dane widoczne w portalu kulturawzasiegu.pl', 'ekultura'),
    'export_post_meta_box',   // Callback function
    'exhibitions',
    'side',
    'high'
  );
}

function export_post_meta_box($object, $box)
{
  $pub_type_t = ['offline', 'online', 'hybrydowe'];

  $is_pn_eventcal = is_plugin_active('the-events-calendar/the-events-calendar.php');
  $is_pn_eventon = is_plugin_active('eventON/eventon.php');
  $is_pn_calendarize = is_plugin_active('calendarize-it/calendarize-it.php');

?>
  <script src="https://cdnjs.cloudflare.com/ajax/libs/chosen/1.8.7/chosen.jquery.min.js"></script>
  <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/chosen/1.8.7/chosen.min.css" type="text/css" media="all">

  <?php $categories = explode(',', get_post_meta($object->ID, 'export_category', true)); ?>
  <p>
    <input class="widefat" type="checkbox" name="export-publish" id="export-publish" value="1" <?php echo (esc_attr(get_post_meta($object->ID, 'export_publish', true)) || empty($object->post_title)) ? 'checked' : ''; ?>>
    <label for="export-publish"><?php _e("Czy wpis ma zostać opublikowany na portalu kulturawzasiegu.pl?", 'ekultura'); ?></label>
  </p>
  <div id="export-for-ekultura" style="display: none;">
    <?php if (!$is_pn_eventcal && !$is_pn_eventon) { ?>
      <p>
        <label for="export-city"><?php _e("Wpisz miasto i ulicę, których dotyczy wpis (należy podać dane oddzielone przecinkiem, np. Toruń, ul. Jana Pawła II)", 'ekultura'); ?></label>
        <br>
        <input class="widefat" type="text" name="export-city" id="export-city" value="<?php echo esc_attr(get_post_meta($object->ID, 'export_city', true)); ?>" size="30" />
      </p>
    <?php } ?>
    <p>
      <label for="export-category"><?php _e("Dziedziny sztuki", 'ekultura'); ?></label>
      <br>
      <select data-placeholder="Kliknij, aby wybrać z listy..." multiple="multiple" class="widefat chosen" name="export-category[]" id="export-category">
        <option value="5" <?php echo in_array(5, $categories) ? 'selected' : ''; ?>>Muzyka i taniec</option>
        <option value="6" <?php echo in_array(6, $categories) ? 'selected' : ''; ?>>Sztuki wizualne</option>
        <option value="7" <?php echo in_array(7, $categories) ? 'selected' : ''; ?>>Teatr</option>
        <option value="11" <?php echo in_array(11, $categories) ? 'selected' : ''; ?>>Film</option>
        <option value="12" <?php echo in_array(12, $categories) ? 'selected' : ''; ?>>Literatura</option>
        <option value="13" <?php echo in_array(13, $categories) ? 'selected' : ''; ?>>Dziedzictwo/Historia/Folklor</option>
        <option value="118" <?php echo in_array(118, $categories) ? 'selected' : ''; ?>>Edukacja</option>
        <option value="167" <?php echo in_array(167, $categories) ? 'selected' : ''; ?>>Interdyscyplinarne</option>
        <option value="190" <?php echo in_array(190, $categories) ? 'selected' : ''; ?>>Inne</option>
      </select>
    </p>
    <p>
      <input class="widefat" type="checkbox" name="export-for-kids" id="export-for-kids" value="1" <?php echo esc_attr(get_post_meta($object->ID, 'export_for_kids', true)) ? 'checked' : ''; ?>>
      <label for="export-for-kids"><?php _e("Dla dzieci", 'ekultura'); ?></label>
    </p>
    <?php if (!$is_pn_eventcal) { ?>
      <p>
        <input class="widefat" type="checkbox" name="export-is-free" id="export-is-free" value="1" <?php echo esc_attr(get_post_meta($object->ID, 'export_is_free', true)) ? 'checked' : ''; ?>>
        <label for="export-is-free"><?php _e("Za darmo", 'ekultura'); ?></label>
      </p>
    <?php } ?>

    <p>
      <input class="widefat" type="checkbox" name="export-is-exhibition" id="export-is-exhibition" value="1" <?php echo esc_attr(get_post_meta($object->ID, 'export_is_exhibition', true)) ? 'checked' : ''; ?>>
      <label for="export-is-exhibition"><?php _e("Wystawa", 'ekultura'); ?></label>
    </p>

    <select name="export-type" id="type" class="chosen">
      <?php
      $spub_type = (int) get_post_meta($object->ID, 'export_type', true);
      for ($i = 0, $i_cnt = count($pub_type_t); $i < $i_cnt; $i++) {
        $selected = ($i === $spub_type) ? 'selected' : '';
        echo "<option value='$i' $selected>{$pub_type_t[$i]}</option>";
      }
      ?>
    </select>


    <p style="display: none;">
      <label for="export-published-to"><?php _e("Data zakończenia publikacji", 'ekultura'); ?></label> <input class="widefat" type="text" name="export-published-to" id="export-published-to" size="30" value="<?php echo esc_attr(get_post_meta($object->ID, 'export_published_to', true)); ?>" />
    </p>
    <?php if (!$is_pn_eventcal && !$is_pn_eventon) { ?>
      <p>
        <label for="organizer-post"><?php _e("Podaj nazwę organizatora (opcjonalnie)", 'ekultura'); ?></label>
        <br />
        <input class="widefat" type="text" name="organizer-post" id="organizer-post" value="<?php echo esc_attr(get_post_meta($object->ID, 'organizer_post', true)); ?>" size="30" />
      </p>
      <p>
        <label for="organizer-object-post"><?php _e("Podaj nazwę obiektu, w którym organizowane jest wydarzenia (opcjonalnie)", 'ekultura'); ?></label>
        <br />
        <input class="widefat" type="text" name="organizer-object-post" id="organizer-object-post" value="<?php echo esc_attr(get_post_meta($object->ID, 'organizer_object_post', true)); ?>" size="30" />
      </p>
    <?php } ?>
    <?php if (!$is_pn_calendarize && !$is_pn_eventcal && !$is_pn_eventon) { ?>
      <p>
        <label for="organizer-object-dates"><?php _e("W przypadku, gdy wpis jest wydarzeniem proszę podać daty (każda z dat w osobnej linii). Jeśli wydarzenie trwa więcej niż jeden dzień należy daty wpisywać oddzielone myślnikiem w tej samej linii. Np. 01.01.2015 - 01.03.2015. <br>Format daty to dzien.miesiac.rok godzina:minuta (godzina i minuta są opcjonalne)", "ekultura"); ?></label>
        <br>
        <textarea style="height: 100px;" class="widefat" name="organizer-object-dates" id="organizer-object-dates" placeholder="01.01.2015 12:00 - 01.03.2015 13:50
05.01.2015"><?php echo esc_attr(get_post_meta($object->ID, 'organizer_object_dates', true)); ?></textarea>
      </p>
    <?php } ?>
  </div>
  <script>
    jQuery(function() {
      jQuery("#publish").click(function(e) {
        var val = jQuery('#export-city').val().trim();

        if (val != '' && val.indexOf(',') == -1) {
          if (!confirm('Adres, w którym ma miejsce to wydarzenie prawdopodobnie jest niepełeny, ponieważ ulica nie jest oddzielona przecinkiem lub też nie została sprecyzowana. Jeśli chcesz opublikować wydarzenie mimo to, kliknij "OK"')) {
            e.preventDefault();
          }
        }
      });

      jQuery("input[name='organizer-post']").autocomplete({
        source: "/?ajax_organizers=true",
        minLength: 2
      });
      jQuery("input[name='organizer-object-post']").autocomplete({
        source: "/?ajax_organizers_objects=true",
        minLength: 2
      });
      jQuery('#export-published-to').datepicker({
        dateFormat: 'dd.mm.yy'
      });
      jQuery('#export-publish').change(function() {
        if (jQuery(this).is(':checked')) {
          jQuery('#export-for-ekultura').show();
          jQuery('#export-category').chosen();
        } else {
          jQuery('#export-for-ekultura').hide();
        }
      }).trigger('change');
    });
  </script>
<?php }


function export_post_meta_boxes_setup()
{
  add_action('add_meta_boxes', 'export_post_meta_boxes');
  add_action('save_post', 'export_save_post_meta', 10, 2);
}

function export_save_post_meta($post_id, $post)
{
  $post_type = get_post_type_object($post->post_type);

  if (!current_user_can($post_type->cap->edit_post, $post_id)) {
    return $post_id;
  }

  $export_publish = isset($_POST['export-publish']) ? $_POST['export-publish'] : 0;

  $export_city = isset($_POST['export-city']) ? $_POST['export-city'] : '';
  update_post_meta($post_id, 'export_publish', $export_publish);
  update_post_meta($post_id, 'export_city', $export_city);


  if (isset($_POST['export-category'])) {
    update_post_meta($post_id, 'export_category', implode(',', $_POST['export-category']));
  }

  $kids = isset($_POST['export-for-kids']) ? $_POST['export-for-kids'] : 0;

  update_post_meta($post_id, 'export_for_kids', $kids);

  $free = isset($_POST['export-is-free']) ? $_POST['export-is-free'] : 0;

  update_post_meta($post_id, 'export_is_free', $free);

  $exhibition = isset($_POST['export-is-exhibition']) ? $_POST['export-is-exhibition'] : 0;

  update_post_meta($post_id, 'export_is_exhibition', $exhibition);

  if (isset($_POST['export-type'])) {
    update_post_meta($post_id, 'export_type', $_POST['export-type']);
  }


  if (isset($_POST['export-published-to-post'])) {
    update_post_meta($post_id, 'export_published_to', $_POST['export-published-to-post']);
  }

  if (isset($_POST['organizer-post'])) {
    update_post_meta($post_id, 'organizer_post', $_POST['organizer-post']);
  }

  if (isset($_POST['organizer-object-dates'])) {
    update_post_meta($post_id, 'organizer_object_dates', $_POST['organizer-object-dates']);
  }

  if (isset($_POST['organizer-object-post'])) {
    update_post_meta($post_id, 'organizer_object_post', $_POST['organizer-object-post']);
  }
}

add_action('load-post.php', 'export_post_meta_boxes_setup');
add_action('load-post-new.php', 'export_post_meta_boxes_setup');


function register_admin_scripts()
{
  wp_enqueue_script('jquery-ui-datepicker');
  wp_enqueue_style('jquery-ui-datepicker', '//ajax.googleapis.com/ajax/libs/jqueryui/1.8.18/themes/smoothness/jquery-ui.css');
}
add_action('admin_init', 'register_admin_scripts');


add_action('init', function () {
  wp_enqueue_script('jquery-ui-autocomplete');

  if (isset($_GET['ajax_organizers'])) {
    global $wpdb;
    $values = $wpdb->get_col("SELECT DISTINCT meta_value FROM $wpdb->postmeta WHERE meta_key = 'organizer_post' AND meta_value != '' AND meta_value LIKE '%" . $_GET['term'] . "%'");
    $result = array();
    foreach ($values as $v) {
      $result[] = array('id' => $v, 'label' => $v, 'value' => $v);
    }
    echo json_encode($result);
    exit;
  }

  if (isset($_GET['ajax_organizers_objects'])) {
    global $wpdb;
    $values = $wpdb->get_col("SELECT DISTINCT meta_value FROM $wpdb->postmeta WHERE meta_key = 'organizer_object_post' AND meta_value != '' AND meta_value LIKE '%" . $_GET['term'] . "%'");
    $result = array();
    foreach ($values as $v) {
      $result[] = array('id' => $v, 'label' => $v, 'value' => $v);
    }
    echo json_encode($result);
    exit;
  }
});
